static char * sccsid = "@(#)  demo11.c  (v1.2 5/15/90)";

/*
 * Is it possible to switch driver to a mode where a character
 * becomes immediately available to a program and it is not echoed ?
 */

# include <stdio.h>
# include <sys/types.h>
# include <sys/timeb.h>
# include <signal.h>

FILE * prot;

int tty_is_set = 0;

struct timeb t0, t1;

finish (n)
	int n;
{
	if (tty_is_set)
		tty_reset();
	exit (n);
}

main (argc, argv)
	int argc;
	char ** argv;
{
	int n;
	char c, c2;
	int ind;

	if ((prot = fopen ("prot", "w")) == NULL) {
		fprintf (stderr, "cannot open prot.\n");
		finish (2);
	}

	printf ("\nWelcome to demo program 11\n\n");
	printf ("I will now try to switch driver into a mode where\n");
	printf ("characters are not echoed and become immediately available\n");
	printf ("to me.\n\n");
	fflush (stdout);

	signal (SIGINT, finish);

	tty_save ();
	tty_is_set = 1;
	tty_cbreak(1);
	tty_echo(0);
	tty_set();

	printf ("Done. Please press any of the character keys\n");
	printf ("e.g. 'a' or '5'. Wait several seconds then press RETURN.\n");

	ind = 0;

	c = fgetc (stdin);
	ftime (&t0);
	c = fgetc (stdin);
	ftime (&t1);
	/*
	 * Compute time difference.
	 */
	n = (t1.time - t0.time) * 1000 + t1.millitm - t0.millitm;
	if (n < 1000) {
		printf ("It does not seem to work correctly (or you cheated)\n");
		printf ("The two characters were available within %1d milliseconds\n",n);
		ind = 1;
	}
	for (;;) {
		printf ("\nWas the character echoed (y/n) ?\n");
		c = fgetc (stdin);
		if  (c == 'n' || c == 'N' || c == 'y' || c == 'Y')
			break;
		printf ("\nPlease type 'y' or 'n'.\n");
		printf ("I ignore anything until the next RETURN.\n");
		while ((c2 = fgetc (stdin)) != '\n')
			;
	}

	if (c == 'y' || c == 'Y') {
		printf ("Switching off echoing did not work either\n");
		ind += 2;
	}

	if (ind == 0) {
		printf ("\nHooray !! It seems to work correctly.\n");
		printf ("Now you may try the next demo programs.\n");
	}

	finish (ind);
}
